about summary refs log tree commit homepage
path: root/t/t0026-splice-copy_stream-byte-range.sh
diff options
context:
space:
mode:
Diffstat (limited to 't/t0026-splice-copy_stream-byte-range.sh')
-rw-r--r--t/t0026-splice-copy_stream-byte-range.sh40
1 files changed, 40 insertions, 0 deletions
diff --git a/t/t0026-splice-copy_stream-byte-range.sh b/t/t0026-splice-copy_stream-byte-range.sh
new file mode 100644
index 0000000..70546b6
--- /dev/null
+++ b/t/t0026-splice-copy_stream-byte-range.sh
@@ -0,0 +1,40 @@
+#!/bin/sh
+. ./test-lib.sh
+test -r random_blob || die "random_blob required, run with 'make $0'"
+case $RUBY_VERSION in
+1.9.*) ;;
+*)
+        t_info "skipping $T since it can't IO::Splice.copy_stream"
+        exit 0
+        ;;
+esac
+check_splice
+
+case $model in
+ThreadSpawn|WriterThreadSpawn|ThreadPool|WriterThreadPool|Base) ;;
+XEpollThreadSpawn) ;;
+*)
+        t_info "skipping $T since it doesn't use copy_stream"
+        exit 0
+        ;;
+esac
+
+t_plan 13 "IO::Splice.copy_stream byte range response for $model"
+
+t_begin "setup and startup" && {
+        rtmpfiles out err
+        rainbows_setup $model
+        cat >> $unicorn_config <<EOF
+require "io/splice"
+Rainbows! do
+  copy_stream IO::Splice
+end
+def (::IO).copy_stream(*x); abort "NO"; end
+EOF
+
+        # can't load Rack::Lint here since it clobbers body#to_path
+        rainbows -E none -D large-file-response.ru -c $unicorn_config
+        rainbows_wait_start
+}
+
+. ./byte-range-common.sh